
class Number {
	int value;
	Number next;

	Number(int v) {
		value = v;
	}

	Number(int v, Number n) {
		value = v;
		next = n;
	}
}

public class Modulo {
	 Number zero;

	// baut eine zyklische Verkettung der Zahlen 0 bis number auf
	 Modulo(int number) {
		Number last = new Number(number - 1);
		Number next = last;
		for (int i = number - 2; i >= 0; i--) {
			Number n = new Number(i, next);
			next = n;
		}
		last.next = next;
		zero = next;
	}

	// liefert den Wert value % number durch value-malige
	// Verfolgung der Verkettung
	int get(int value) {
		Number current = zero;
		for (int i = 0; i < value; i++) {
			current = current.next;
		}
		return current.value;
	}

	public static void main(String[] args) {
		Modulo m = new Modulo(4);
		System.out.println(m.get(7)); // 7 % 4 --> 3
		System.out.println(m.get(17)); // 17 % 4 --> 1

		m = new Modulo(11);
		System.out.println(m.get(7)); // 7 % 11 --> 7
		System.out.println(m.get(35)); // 35 % 11 --> 2
	}

}
