
class DoubleSideStack {

	private ArrayList elems;

	public DoubleSideStack() {
		elems = new ArrayList();
	}

	// liefert genau dann true, wenn sich kein Element auf dem DoubleSideStack
	// befindet
	public boolean isEmpty() {
		return elems.size() == 0;
	}

	// fuegt den uebergebenen Wert auf der rechten Seite des DoubleSideStacks an
	public void pushRight(int value) {
		elems.add(value);
	}

	// entfernt das am weitesten rechts liegende Element aus dem DoubleSideStack
	// und liefert es als Methodenwert
	public int popRight() {
		return elems.removeAtIndex(elems.size() - 1);
	}

	// fuegt den uebergebenen Wert auf der linken Seite des DoubleSideStacks an
	public void pushLeft(int value) {
		elems.insert(0, value);
	}

	// entfernt das am weitesten links liegende Element aus dem DoubleSideStack
	// und liefert es als Methodenwert
	public int popLeft() {
		return elems.removeAtIndex(0);
	}

	// Testprogramm
	public static void main(String[] args) {
		DoubleSideStack stack = new DoubleSideStack();
		stack.pushLeft(23);
		stack.pushLeft(-34);
		stack.pushRight(5);
		stack.pushLeft(-8);
		stack.pushRight(67);
		System.out.println(stack.popLeft());
		System.out.println(stack.popRight());
	}
}
